{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}


unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,

  System.Data, // ADO.NET
  System.collections, // iList interface
  Borland.Data.Provider, Borland.Data.Common, // BDP

  Borland.Vcl.Grids,
  Borland.Vcl.DBGrids, Borland.Vcl.Db, System.ComponentModel,
  Borland.Vcl.ADONETDb, Borland.Vcl.StdCtrls, Borland.Vcl.ExtCtrls,
  Borland.Vcl.DBCtrls;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Button1: TButton;
    DBNavigator1: TDBNavigator;
    Button2: TButton;
    ListConnector1: TListConnector;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    BdpCon : BdpConnection;
    Adods: DataSet;
    Adotab: DataTable;
    BdpSel: BdpCommand;
    Bdpda: BdpDataAdapter;
    BdpCB: BdpCommandBuilder;
  public
    Procedure Connect;
  end;

var
  Form1: TForm1;

implementation

{$R *.nfm}

{ TForm1 }

procedure TForm1.Connect;
var i:integer;
begin
  BdpCon:=BdpConnection.Create(
          'assembly=Borland.Data.Interbase, Version=2.5.0.0, '+
          'Culture=neutral, PublicKeyToken=91d62ebb5b0d1b1b;vendorclient=gds32.dll;'+
          'pooling=True;grow on demand=True;'+
          'database=..\data\DBDEMOS.GDB;username=sysdba;'+
          'max pool size=100;password=masterkey;provider=Interbase');

  // Crer le nouveau dataset
  Adods := DataSet.Create;
  // Crer un objet table
  AdoTab := Adods.Tables.Add('CUSTOMER');

  // Crer l'objet commande qui ira chercher les donnes par un SELECT
  BdpSel := BdpCommand.Create('SELECT CUSTNO, PHONE, CONTACT, LASTINVOICEDATE FROM CUSTOMER',BdpCon);

  // Crer l'adaptateur de donnes
  Bdpda := BdpDataAdapter.Create;

  // Lier l'objet commande  l'objet adaptateur
  Bdpda.SelectCommand := BdpSel;

  // Crer le command builder qui crira le SQL de mise  jour pour nous
  BdpCB := BdpCommandBuilder.Create(Bdpda);

  // Lier l'adaptateur au dataset et  sa table
  Bdpda.DataSet:=Adods;
  Bdpda.DataTable := AdoTab;


  // Demander  l'adaptateur de remplir le dataset
  Bdpda.Active:=True;


  // Connecter le ListConnector  la table et l'activer
  ListConnector1.DataObject := Adods.Tables[0].DefaultView;
  ListConnector1.Active:=True;

  // effet cosmetique pour rduire la taille des colonnes string
  for i:=0 to Dbgrid1.Columns.Count-1 do
   if dbgrid1.Columns[i].Field.DataType=TfieldType.ftWideString then
       dbgrid1.Columns[i].Width := 200;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 Connect;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 BdpCon.Open;
 Bdpda.Update(adoTab);
 BdpCon.Close;
end;

end.
